<?php
/*

 $Id: soa.php,v 1.10 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /a1/cvsroot/maint/docs/soa.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


/*!
	@header Source of Authority Document
	All of the admin related soa stuff (SOA, delegates, etc).

*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
        if (!check_session()) { logout(); }
	
	setup_user_environment($action, $zone_id);
/* End House Keeping */

// Sorry, only admins here
if ( ! $user->is_admin ) {
	header("Location: " . $conf['web_path'] . "/index.php");
	exit();
}

// Let's get this outta the way now
if ( $domain_id ) {
        $domain = new Domain($domain_id);

	// we need to pull SOA info from the database
	if ( $action == 'show_soa' && ! $soa_id ) {
		$sql = "SELECT * FROM soa WHERE domain='$domain_id'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$soa_obj = mysql_fetch_object($db_result);
		$soa_id = $soa_obj->id;
	}
}

if ( $soa_id ) {
	$soa = new SOA($soa_id);
}

if ( $action == 'Update' ) {
	$action = 'update_soa';
}
elseif ( $action == 'Delete' ) {
	$action = 'delete_soa';
}

if ( $action == 'update_soa' ) {
	// this is an error condition
	if ( ! $soa_id ) {
		$conf['error']->add_error('primary_master', "You must specify which SOA you are working on.");
	}

	if ( ! $primary_master ) { 
		$conf['error']->add_error('primary_master', "Please specify a primary master nameserver.");
	}

	if ( ! $hostmaster ) { 
		$conf['error']->add_error('mail_address', "Please specify a mail address for this domain.");
	}
	
	if ( ! $refresh || ! is_numeric($refresh) ) { 
		$conf['error']->add_error('refresh', "Please specify valid refresh time.");
	}

	if ( ! $retry || ! is_numeric($retry) ) { 
		$conf['error']->add_error('retry', "Please specify valid retry time.");
	}
	
	
	if ( ! $expire || ! is_numeric($expire) ) { 
		$conf['error']->add_error('expire', "Please specify valid expire time.");
	}
	
	if ( ! $ttl || ! is_numeric($ttl) ) { 
		$conf['error']->add_error('ttl', "Please specify valid TTL time."); 
	}

	if ($ttl < 300) { 
		$conf['error']->add_error('ttl', "TTL time must be greater than 300.");
	}

	if (!$conf['error']->error_state) {
		
		$soa->update_primary_master($primary_master);
		$soa->update_hostmaster($hostmaster);
		$soa->update_refresh($refresh);
		$soa->update_retry($retry);
		$soa->update_expire($expire);
		$soa->update_ttl($ttl);
		$soa->object_history->update($user->username,$comment);

	} // no errors

	// do some soa stuff
	$action      = 'show_soa';
}
elseif ( $action == 'insert_nameserver' ) {
	if ( ! $nameserver ) {
		$conf['error']->add_error('nameserver', "Please specify a valid nameserver."); 
	}
	else {
		$ns_id = $soa->insert_nameserver($nameserver);

		// if the glue is present, then add it
		if ( $glue ) {
			$soa->insert_glue($glue, $ns_id);
		}
	}

	$action = 'show_soa';
}
elseif ( $action == 'delete_nameserver' ) {
	if ( ! $ns_id ) {
                $conf['error']->add_error('nameserver', "Please specify a valid nameserver.");
        }
        else {
                $soa->delete_nameserver($ns_id);
        }

	$action = 'show_soa';
}
elseif ( $action == 'create_soa' ) {

	// the most important thing is that we have the domain_id
	if ( !$domain_id ) {
		$conf['error']->add_error('incomplete_form', 'You must specify a domain for this SOA to be associated with.');
		$action = 'show_create';
	}
	else {
		// create the SOA with the domain_id
		$soa = new SOA(0);
		$soa_id = $soa->create($domain_id);
		$soa = new SOA($soa_id);

		$db_result = mysql_query($sql, $conf['dbh']);
		
		// create the SOA with the domain_id
		// check the form fields
		if ( !$primary_master ) {
			$conf['error']->add_error('primary_master', 'Please specify a primary master host.');
		}
		else {
			if ( preg_match("/[\w]+\.[\w]+/", $primary_master) ) {
				$soa->update_primary_master($primary_master);
			}
			else {
				$conf['error']->add_error('primary_master', 'That is an invalid hostname.');
			}
		}

		if ( !$hostmaster ) { 
                        $conf['error']->add_error('hostmaster', 'Please specify a hostmaster.');
                } 
                else { 
			if ( preg_match("/\@/", $hostmaster) ) {
                                $conf['error']->add_error('hostmaster', "This field should not contain the '@' sign.");
			}
			elseif ( preg_match("/[\w]+\.[\w]+/", $hostmaster) ) {
                                $soa->update_hostmaster($hostmaster);
                        }
                        else {
                                $conf['error']->add_error('primary_master', 'That is an invalid hostmaster.');
                        }
                } 

		if ( !$retry || ! is_numeric($retry) ) {    
                        $conf['error']->add_error('retry', 'Please specify a valid retry time.');
                }
                else {
                        $soa->update_retry($retry);
                } 

		if ( !$refresh || !is_numeric($refresh) ) {
                        $conf['error']->add_error('refresh', 'Please specify a valid refresh time.');
                }
                else {
                        $soa->update_refresh($refresh);
                }

		if ( !$expire || !is_numeric($expire) ) {
                        $conf['error']->add_error('expire', 'Please specify a valid expire time.');
                }
                else {
                        $soa->update_expire($expire);
                }

		if ( !$ttl || !is_numeric($ttl) ) {
                        $conf['error']->add_error('ttl', 'Please specify a valid ttl time.');
                }
                else {
                        $soa->update_ttl($ttl);
                }
	}
}
elseif ( $action == 'really_delete_soa' ) {
	// delete any associated nameserver records
	$nameservers = $soa->get_nameservers();

	foreach ($nameservers as $nameserver) {
		$soa->delete_nameserver($nameserver->id);
	}

	// delete the actual domain
	$soa->domain->delete_domain($soa->domain->id);

	// delete associated hosts as well?

	// delete the SOA
	$soa->delete();

	// just redirect them to the root of Maintain
	$redirect = $conf['web_path'];
	header("Location: $redirect");
}
elseif ( $action == 'delegate' ) {
	$soa->add_delegation();
	$action = 'show_soa';
}
elseif ( $action == 'remove_delegation' ) {
	$soa->remove_delegation();
	$action = 'show_soa';
}
// we want to create a new SOA for a domain
elseif ( $domain_id and ! $soa_id ) {
	$action = 'show_create';
}

show_template('header');

if ( $action == 'delete_soa' ) {
	// we need to show a confirmation message here
	$domain_name = $soa->domain->name;
	$conf['ui']->show_confirm("/soa.php?action=really_delete_soa&soa_id=$soa->id","Are you sure you want to delete this SOA record (and the associated domain $domain_name)?");
}
else {
	require $conf['prefix'] . "/templates/show_soa.inc";
}

show_template('footer');

?>
